// Generated by Create API
// https://github.com/CreateAPI/CreateAPI
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1 {
    public var actors: Actors {
        Actors(path: path + "/actors")
    }

    public struct Actors {
        /// Path: `/v1/actors`
        public let path: String

        public func get(filterID: [String], fieldsActors: [FieldsActors]? = nil, limit: Int? = nil) -> Request<_Specification.ActorsResponse> {
            Request(path: path, method: "GET", query: makeGetQuery(filterID, fieldsActors, limit), id: "actors-get_collection")
        }

        private func makeGetQuery(_ filterID: [String], _ fieldsActors: [FieldsActors]?, _ limit: Int?) -> [(String, String?)] {
            let encoder = URLQueryEncoder(explode: false)
            encoder.encode(filterID, forKey: "filter[id]")
            encoder.encode(fieldsActors, forKey: "fields[actors]")
            encoder.encode(limit, forKey: "limit")
            return encoder.items
        }

        public enum FieldsActors: String, Codable, CaseIterable {
            case actorType
            case apiKeyID = "apiKeyId"
            case userEmail
            case userFirstName
            case userLastName
        }
    }
}
