// Generated by Create API
// https://github.com/CreateAPI/CreateAPI
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1 {
    public var betaBuildLocalizations: BetaBuildLocalizations {
        BetaBuildLocalizations(path: path + "/betaBuildLocalizations")
    }

    public struct BetaBuildLocalizations {
        /// Path: `/v1/betaBuildLocalizations`
        public let path: String

        public func get(filterLocale: [String]? = nil, filterBuild: [String]? = nil, fieldsBetaBuildLocalizations: [FieldsBetaBuildLocalizations]? = nil, limit: Int? = nil, include: [Include]? = nil, fieldsBuilds: [FieldsBuilds]? = nil) -> Request<_Specification.BetaBuildLocalizationsResponse> {
            Request(path: path, method: "GET", query: makeGetQuery(filterLocale, filterBuild, fieldsBetaBuildLocalizations, limit, include, fieldsBuilds), id: "betaBuildLocalizations-get_collection")
        }

        private func makeGetQuery(_ filterLocale: [String]?, _ filterBuild: [String]?, _ fieldsBetaBuildLocalizations: [FieldsBetaBuildLocalizations]?, _ limit: Int?, _ include: [Include]?, _ fieldsBuilds: [FieldsBuilds]?) -> [(String, String?)] {
            let encoder = URLQueryEncoder(explode: false)
            encoder.encode(filterLocale, forKey: "filter[locale]")
            encoder.encode(filterBuild, forKey: "filter[build]")
            encoder.encode(fieldsBetaBuildLocalizations, forKey: "fields[betaBuildLocalizations]")
            encoder.encode(limit, forKey: "limit")
            encoder.encode(include, forKey: "include")
            encoder.encode(fieldsBuilds, forKey: "fields[builds]")
            return encoder.items
        }

        public enum FieldsBetaBuildLocalizations: String, Codable, CaseIterable {
            case build
            case locale
            case whatsNew
        }

        public enum Include: String, Codable, CaseIterable {
            case build
        }

        public enum FieldsBuilds: String, Codable, CaseIterable {
            case app
            case appEncryptionDeclaration
            case appStoreVersion
            case betaAppReviewSubmission
            case betaBuildLocalizations
            case betaGroups
            case buildAudienceType
            case buildBetaDetail
            case buildBundles
            case computedMinMacOsVersion
            case diagnosticSignatures
            case expirationDate
            case expired
            case iconAssetToken
            case icons
            case individualTesters
            case lsMinimumSystemVersion
            case minOsVersion
            case perfPowerMetrics
            case preReleaseVersion
            case processingState
            case uploadedDate
            case usesNonExemptEncryption
            case version
        }

        public func post(_ body: _Specification.BetaBuildLocalizationCreateRequest) -> Request<_Specification.BetaBuildLocalizationResponse> {
            Request(path: path, method: "POST", body: body, id: "betaBuildLocalizations-create_instance")
        }
    }
}
